#define MpiUtilCC

#include "LDASConfig.h"
   
// System Header Files
#include <new>   
   
#include <unistd.h> 
#include <cerrno>   
#include <cstring>   
#include <sstream>   
#include <algorithm>

// Local Header Files   
#include "mpicmdargs.hh"   
#include "mpiutil.hh"
#include "ldaserror.hh"
#include "initvars.hh"   
#include "ldasrequest.hh"   
#include "ldastag.hh" 
#include "mpilaltypes.hh"   

using namespace std;      

   
//#define LDAS_CHECK_MEMORY   
   
// Static data member initialization   
INT8 DLErrorHandler::mMaxMemory( 0 );
void* DLErrorHandler::mInitBreak( 0 );   

   
//-------------------------------------------------------------------------------   
//      
//: Constructor
//
//!param: const CHAR* func - Name of the dynamic library function for which     
//+       error checking is done. Default is NULL.
//!param: const INT4 code - Error code generated by <i>func</i> function.
//+       Default is 0.   
//!param: const CHAR* msg - Error/warning message generated by <i>func</i>      
//+       function. Default is NULL.
//   
DLErrorHandler::DLErrorHandler( const CHAR* func, const INT4 code, 
   CHAR* msg )
{
   mInitBreak = sbrk( 0 );
   operator()( func, code, msg );
}
   

//-------------------------------------------------------------------------------   
//         
//: Overloaded call operator
// 
//!param: const CHAR* func - Name of the dynamic library function for which     
//+       error checking is done.
//!param: const INT4 code - Error code generated by <i>func</i> function.
//!param: const CHAR* msg_str - Error/warning message generated by <i>func</i>      
//+       function.
//!param: const MPI::Intracomm& comm - A reference to the intracommunicator     
//+       within which domain communication occures. Default is MPI::COMM_WORLD.
//!param: const bool p2p - A flag to indicate if error checking is done for p2p        
//+       type of communication. Default is false.      
//  
//!return: Nothing.     
//   
//!exc: ( <i>func</i> function ): undefined error code = <i>c</i>. -  
//+     Node reported undefined error code <i>c</i> when calling <i>func</i> 
//+     function. Function return code is one of -1 | 0 | 1.
//!exc: ( <i>func</i> function ): msg_str. - Node failed with <i>msg</i> error
//+     when calling <i>func</i> function.    
//!exc: Memory allocation failed. - Error allocating memory.      
//!exc: Error in sysconf: error message. - Error occured when making call to 
//+     sysconf(): error message..   
//!exc: Error in sbrk( 0 ): error message. - Error occured when making call to
//+     sbrk( 0 ): error message.   
//!exc: Memory usage exceeded maximum allowed. - Process exceeded maximum
//+     allowed memory usage limit.      
//   
void DLErrorHandler::operator() ( const CHAR* func, const INT4 code, 
   CHAR* msg_str, const MPI::Intracomm& comm, const bool p2p )
try   
{
   // Remove '\n' from dso reported error messages( mpiAPI uses
   // '\n' to parse received messages from wrapperAPI )
   string msg;
   
   if( msg_str != 0 && strlen( msg_str ) )
   {
      msg += msg_str;
      string new_line( "\n" );
      string::size_type pos( 0 );   
   
      while( ( pos = msg.find_first_of( new_line, pos ) ) != string::npos )
      {
         msg.replace( pos, 1, " " );
      }
   }

   
   switch( code )
   {
      case(DLWarning):
      {
         ostringstream s;
   
         s << "Node " << myNode << "( " << func << " function ): " << msg;
   
         if( !mWarningMsg.empty() )
         {
            mWarningMsg += " ";
         }
   
         mWarningMsg += s.str();
   
         break;
      }
      case(DLNominal):
      {
         break;
      }
      case(DLError):
      {
         ostringstream s;
   
         s << "( " << func << " function ): " << msg;
   
         if( !mErrorMsg.empty() )
         {
            mErrorMsg += " ";
         }   
   
         mErrorMsg += s.str();
   
   
         // Prepend warning message to the error message
         // if it is not empty.
         if( mWarningMsg.empty() == false )
         {
             mErrorMsg += " ";
             mErrorMsg += mWarningMsg;
         }
   

         free( msg_str );   
         msg_str = 0;
         node_error( mErrorMsg.c_str(), comm, p2p );
   
         break;
      }
      default:
      {
         ostringstream s;
   
         s << "( " << func << " function ): undefined error code = " << code;
   
         if( !mErrorMsg.empty() )
         {
            mErrorMsg += " ";
         }            
   
         mErrorMsg += s.str();
         node_error( mErrorMsg.c_str(), comm, p2p );
   
         break;
      }
   }

   // Check memory usage on the node
   return checkMemory( func, comm, p2p );
}
catch( const bad_alloc& exc )
{
   node_error( exc, comm, p2p );
}
   

//-------------------------------------------------------------------------------   
// 
//: Resets descriptive error and warning messages.
//      
//!return: Nothing.
//   
void DLErrorHandler::resetMessages()
{
   return resetMessages( mWarningMsg, mErrorMsg );
}   
   
   
//-------------------------------------------------------------------------------   
// 
//: Gets maximum memory usage.
//      
// This method returns the value of maximum memory used by the process.
//   
//!return: const INT8 - Memory value.
//   
const INT8 DLErrorHandler::getMaxMemory()
{
   return mMaxMemory;
}
   
   
//-------------------------------------------------------------------------------   
// 
//: Resets messages.
//      
// This method resets passed to it messages to the empty strings.
//!ignore_begin:   
// Use 'std' namespace in method arguments( even though we said
// 'using namespace std' ) because perceps won't create proper link 
// for the documentation if we don't use it.
//!ignore_end:   
//   
//!param: string& war_msg - A reference to the string containing warning message.
//!param: string& err_msg - A reference to the string containing error message.   
//   
//!return: Nothing.
//   
void DLErrorHandler::resetMessages( std::string& war_msg, std::string& err_msg )
{
   if( !war_msg.empty() )
   {
      war_msg.erase();
   }

   
   if( !err_msg.empty() )
   {
      err_msg.erase();   
   }
   
   
   return;
}   
   
   
//-------------------------------------------------------------------------------   
// 
//: Checks memory usage.
//      
// This method checks current memory usage by the process and raises an 
// exception if more than allowed percentage is used.   
//   
//!param: const CHAR* func - Name of the dynamic library function for which     
//+       error checking is done.   
//!param: const MPI::Intracomm& comm - A reference to the intracommunicator     
//+       within which domain communication occures.
//!param: const bool p2p - A flag to indicate if error checking is done for p2p        
//+       type of communication. 
//   
//!return: Nothing.
//   
//!exc: Error in sysconf: error message. - Error occured when making call to 
//+     sysconf(): error message..   
//!exc: Error in sbrk( 0 ): error message. - Error occured when making call to
//+     sbrk( 0 ): error message.   
//!exc: Memory usage exceeded maximum allowed. - Process exceeded maximum
//+     allowed memory usage limit.   
//   
void DLErrorHandler::checkMemory( const CHAR* func, const MPI::Intracomm& comm,
   const bool p2p )
{
   static bool initTotalMemory( true );
   static INT8 total_memory( 0 );
   
   if( initTotalMemory )
   {
      INT8 page_size( sysconf( _SC_PAGE_SIZE ) );
      if( page_size <= 0 )
      {
         string msg( "Error in sysconf( _SC_PAGE_SIZE ): " );
         msg += strerror( errno );
      
         node_error( msg.c_str(), comm, p2p );
      }   
   
      total_memory = sysconf( _SC_PHYS_PAGES );   
   
      if( total_memory <= 0 )
      {
         string msg( "Error in sysconf( _SC_PHYS_PAGES ): " );
         msg += strerror( errno );
      
         node_error( msg.c_str(), comm, p2p );
      }

      // Get memory in bytes
      total_memory *= page_size;
      initTotalMemory = false;
   }
   
   void* curr_break( sbrk( 0 ) );   
   if( curr_break == 0 )
   {
      string msg( "Error in sbrk( 0 ): " );
      msg += strerror( errno );
      
      node_error( msg.c_str(), comm, p2p );      
   }
   
   INT8 curr_memory( static_cast< CHAR* >( curr_break ) -
                     static_cast< CHAR* >( mInitBreak ) );

#ifdef LDAS_CHECK_MEMORY               
   if( myNode == masterNode )
   {
      cout << "Used memory = " << curr_memory << endl;
   }      
#endif   
   
   if( ( static_cast< REAL8 >( curr_memory ) / 
         static_cast< REAL8 >( total_memory ) ) > memoryUsageLimit )
   {
#ifdef LDAS_CHECK_MEMORY         
      cout << "Total memory = " << total_memory 
           << ", used memory = " << curr_memory 
           << ", memoryRatio = " 
           << ( static_cast< REAL8 >( curr_memory ) / 
                static_cast< REAL8 >( total_memory ) ) << endl; 
#endif   

      string msg( "Memory usage exceeded maximum allowed( " );
      if( func != 0 && *func != '\0' )
      {
         msg += func;
      }
      msg += " )";
      node_error( msg.c_str(), comm, p2p );
   }

   
   if( curr_memory  > mMaxMemory )
   {
      mMaxMemory = curr_memory;
   }   
   
   
   return;
}
   
   
//-------------------------------------------------------------------------------   
//   
//: Checks if current node belongs to the group of nodes.
//   
// This method checks if current node belongs to the specified group of nodes.
//
//!param: const vector< INT4 >& ranks - A reference to the vector representing  
//+       group of nodes.
//!param: const INT4 rank - Rank of the node to search for.  
//
//!return: bool - True if node belongs to the group, false otherwise.
//   
bool inRanks( const vector< INT4 >& ranks, const INT4 rank )
{
   return ( find( ranks.begin(), ranks.end(), rank ) != ranks.end() );
}


//-------------------------------------------------------------------------------   
//   
//: Creates notNodes set of slaves.
//   
// This method recreates <i>notNodes</i> vector of nodes that are not in the load
// balancing communicator.
//
//!param: const UINT4& num - A reference to the number of nodes in the         
//+       MPI::COMM_WORLD. In MPICH implementation it is a const value, in  
//+       LAM there is a possibility to change COMM_WORLD during parallel job.  
//    
//!return: Nothinig.
//   
void createNotLBNodes( const UINT4& num ) 
{
   notNodes.erase( notNodes.begin(), notNodes.end() );

   // Skip wrapperMaster( start with 1 )   
   static const INT4 start( 1 );
   

   for( UINT4 i = start; i < num; ++i )
   {
      if( !inRanks( nodes, i ) )
      {
         notNodes.push_back( i );
      }
   }
   
   
   return;
}
   

//-------------------------------------------------------------------------------   
//   
//: Builds a C-type communicator.   
// 
// This helper method builds a C-type communicator for use in the dynamically
// loaded shared object functions.   
//
//!param: const vector< INT4 >& - A reference to the vector of node ranks to be 
//+       included into the communicator.
//!param: MPI_Comm& - A pointer to the C-type communicator to recreate.
//
//!return: Nothing.
//   
//!exc: Error creating C type group of nodes. - Could not create new C type     
//+     group of nodes for communicator generation.   
//!exc: Error creating C type communicator. - Could not create C-type communicator.   
//!exc: MPI::Exception - MPI library exception.   
//   
void createComm( vector< INT4 >& ranks, MPI_Comm* comm ) 
{
   if( *comm != MPI_COMM_NULL )
   {
      MPI_Comm_free( comm );
   }
   
   
   MPI_Group wGroup, cGroup;
   
   MPI_Comm_group( MPI_COMM_WORLD, &wGroup );
   
   
   // Initialize array of ranks for new group
   INT4 size( ranks.size() );
   
   if( size == 0 )   
   {
      node_error( "Empty rank array passed to createCommunicator.",
                  MPI::COMM_WORLD, false );
   }
   
 
   // Create new group for the communicator
   MPI_Group_incl( wGroup, size, &( ranks[ 0 ] ), &cGroup );
   
   
   if( cGroup == MPI_GROUP_NULL )
   {
      node_error( "Error creating C type group of nodes.",
                  MPI::COMM_WORLD, false );
   }
   
   node_error.pass( MPI::COMM_WORLD, false );
   
   // Create new communicator
   MPI_Comm_create( MPI_COMM_WORLD, cGroup, comm );
   
   
   if( inRanks( ranks, myNode ) && *comm == MPI_COMM_NULL )
   {
      node_error( "Error creating C type communicator.",
                  MPI::COMM_WORLD, false );   
   }
   
   
   // Memory cleanup
   MPI_Group_free( &wGroup );
   MPI_Group_free( &cGroup );   
   
   
   return;
}

   
#define USE_OPTIONAL      

//-------------------------------------------------------------------------------   
//   
//: Hard-coded outPut structure generation.
//    
// This method is to simulate outPut data structure generation by dso.
// Used only for debugging purposes.
//
//!param: outPut** out - A pointer to the array of outPut data structures to    
//+       be allocated.
//!param: const UINT4 num - A number of array elements to allocate.
//
//!return: Nothing.
//
//!exc: bad_alloc - Memory allocation failed.
//   
void buildOutputStruct( outPut** out, const UINT4 num ) 
{
   // Building array of num elements
   stateVector* curr_state( 0 ), *prev_state( 0 );
   bool first_node( true );
   
   string name;
   const CHAR* tmp( 0 );   
   
   
   *out = new outPut[ num ];
   memset( *out, 0, sizeof( outPut ) * num );
   
   
   outPut* outs( 0 );

   REAL4 val( 0.0 );
   ostringstream state_name;   

   const CHAR* db_query( "SQL=test query" );
   
   const UINT4 num_channels( 5 );
   static CHAR* c_list[ num_channels ] = { "CH1:AA_BB",
                                           "CH2:CC_DD",
                                           "CH3:ee:ff",
                                           "CH4",
                                           "CHANNEL5" };
   UINT4 channel_buf_size( 0 );
   for( UINT4 i = 0; i < num_channels; ++i )
   {
      channel_buf_size += strlen( c_list[ i ] ) + 1;
   }

   const CHAR* mdd_comment( "Testing multiDimData comment field." );
   UINT4 channel_offset( 0 );
   CHAR* channel_buffer( 0 );
   const UINT4 num_detector( 5 );
   
   for( UINT4 i = 0; i < num; ++i )
   {
      outs = &( ( *out )[ i ] );
   
     //cout << "buildOutput: " << i << endl;
      outs->indexNumber = 100 + i;
      outs->search = burst;
      outs->significant = true;
      //cout << "Significant = " << out[ i ].significant << endl;
   
      // Allocate memory for states linked list
      prev_state = 0;
      first_node = true;
   
      for( UINT4 k = 0; k <= 2; ++k )
      {
         curr_state = new stateVector;
         memset( curr_state, 0, sizeof( stateVector ) );
   
         if( first_node )
         {
            outs->states = curr_state;
            first_node = false;
         }
         else
         {
            prev_state->next = curr_state;
            curr_state->previous = prev_state;
         }
   
         prev_state = curr_state;
      }
   
      // Initialize data for states
      curr_state = outs->states;   

      while( curr_state != 0 )
      {
         state_name.seekp( ios::beg );
         state_name << "StateName_";
         state_name << i << "_rank_" << myNode;

         const string& tmp_name( state_name.str() );
         //cout << tmp_name << " for " << i << endl;
	 std::copy( tmp_name.begin(), tmp_name.end(),
                    curr_state->stateName );

                     
         // Allocate memory for states->store
         curr_state->store = new multiDimData[ 1 ];
         memset( curr_state->store, 0, sizeof( multiDimData ) );
   
         // Set states->store data
         curr_state->store[ 0 ].numberDimensions = 1;
         curr_state->store[ 0 ].dimensions = new UINT4[ 1 ];
         curr_state->store[ 0 ].dimensions[ 0 ] = 10;
   
         // Init name
         name = "StateStore";
         tmp = name.c_str();
         //cout << tmp << " for " << i << endl;
   
         memcpy( curr_state->store[ 0 ].name, tmp, strlen( tmp ) );
         // Init units
         name = "StateStoreUnits";
         tmp = name.c_str();
         //cout << tmp << " for " << i << endl;
   
         memcpy( curr_state->store[ 0 ].units, tmp, strlen( tmp ) );         
   
         memcpy( curr_state->store[ 0 ].comment, 
                 mdd_comment, strlen( mdd_comment ) );            

         curr_state->store[ 0 ].history = new dcHistory;
         memset( curr_state->store[ 0 ].history, 0, sizeof( dcHistory ) );
     
         name = "NoHistoryPresent";
         tmp = name.c_str();
         memcpy( curr_state->store[ 0 ].history->name, tmp, strlen( tmp ) );
         tmp = "historyUnits";
         memcpy( curr_state->store[ 0 ].history->units, tmp, strlen( tmp ) ); 
   
         if( i == 0 )
         {
            curr_state->store[ 0 ].history->type = char_s;
            curr_state->store[ 0 ].history->numberValues = 10;
            curr_state->store[ 0 ].history->value.chars = new CHAR[ 10 ];
            tmp = "ab,cd,ef,g";
            memcpy( curr_state->store[ 0 ].history->value.chars, tmp, 
               sizeof( CHAR ) * 10 );   
         }
         else
         {
            curr_state->store[ 0 ].history->type = int_2s;
            curr_state->store[ 0 ].history->numberValues = 1;
            curr_state->store[ 0 ].history->value.int2s = new INT2[ 1 ];
            curr_state->store[ 0 ].history->value.int2s[ 0 ] = 89;
         }

         // Test databaseD domain
         if( i == 0 )
         {
            curr_state->store[ 0 ].space = databaseD;
            curr_state->store[ 0 ].type = real_4;
            curr_state->store[ 0 ].range.dDatabase.numberRows =
               curr_state->store[ 0 ].dimensions[ 0 ];
            memcpy( curr_state->store[ 0 ].range.dDatabase.sqlQuery,
                    db_query, sizeof( CHAR ) * strlen( db_query ) );            
   
         }
         else
         {
            curr_state->store[ 0 ].space = timeD;
            curr_state->store[ 0 ].type = real_4;
            curr_state->store[ 0 ].range.dTime.numberSamples = 10;
            curr_state->store[ 0 ].range.dTime.startSec = 678904;
            curr_state->store[ 0 ].range.dTime.startNan = 0;
            curr_state->store[ 0 ].range.dTime.stopSec = 678905;
            curr_state->store[ 0 ].range.dTime.stopNan = 0;
            curr_state->store[ 0 ].range.dTime.timeStepSize = 0.1;   
    
            // Test channel names
            curr_state->store[ 0 ].range.dTime.numberChannels = num_channels;   
            curr_state->store[ 0 ].range.dTime.channelName = 
               new CHAR*[ num_channels ];
            memset( curr_state->store[ 0 ].range.dTime.channelName, 0, 
                    sizeof( CHAR* ) * num_channels );
              
            curr_state->store[ 0 ].range.dTime.channelName[ 0 ] = 
               new CHAR[ channel_buf_size ];
            memset( curr_state->store[ 0 ].range.dTime.channelName[0], 0, 
                    sizeof( CHAR ) * channel_buf_size );
   

            channel_offset = 0;
            channel_buffer = curr_state->store[ 0 ].range.dTime.channelName[ 0 ];
            for( UINT4 ch = 0; ch < num_channels; ++ch )
            {
               strcpy( channel_buffer + channel_offset, c_list[ ch ] );

               // set a pointer to the name
               if( ch != 0 )
               {
                  curr_state->store[ 0 ].range.dTime.channelName[ ch ] =
                     channel_buffer + channel_offset;                     
               }
          
#ifdef DISPLAY_CHANNEL   
               cout << "State channel[" << ch << "]=" << 
                  curr_state->store[ 0 ].range.dTime.channelName[ ch ] << endl;
#endif   
   
               channel_offset += strlen( c_list[ ch ] ) + 1;   
            }
   
            // Test detector geometry
            curr_state->store[ 0 ].range.dTime.numberDetectors = num_detector;    
            curr_state->store[ 0 ].range.dTime.geometry = 
               new detGeom[ num_detector ];
            memset( curr_state->store[ 0 ].range.dTime.geometry, 0, 
                    sizeof( detGeom ) * num_detector );   
   
            for( UINT4 d_index = 0; d_index < num_detector; ++d_index )
            {
               std::copy( tmp_name.begin(), tmp_name.end(),
                          curr_state->store[ 0 ].range.dTime.geometry[ d_index ].name );

               curr_state->store[ 0 ].range.dTime.geometry[ d_index ].latitude =    
                  d_index * 10.0f;
            }
         }

         curr_state->store[ 0 ].data.real4 = 
            new REAL4[ curr_state->store[ 0 ].dimensions[ 0 ] ];         
   
         for( UINT4 j = 0; 
              j < curr_state->store[ 0 ].dimensions[ 0 ]; ++j )
         {
             curr_state->store[ 0 ].data.real4[ j ] = val + 
                static_cast< REAL4 >( j ) * 0.01;
         }
         
         curr_state = curr_state->next;
      }
      
      // Init dataBase:
      name = "DataBaseTable";
      tmp = name.c_str();
   
      outs->results = new dataBase;
      memset( outs->results, 0, sizeof( dataBase ) );
   
      memcpy( outs->results->tableName, tmp, strlen( tmp ) );
   
      name = "DataBaseColumn";
      tmp = name.c_str();
      memcpy( outs->results->columnName, tmp, strlen( tmp ) );   
   
      
      outs->results->type = int_2u;
      outs->results->numberRows = i + 20;
      outs->results->rows.int2u = 
         new UINT2[ outs->results->numberRows ];
   
      for( UINT4 k = 0; k < outs->results->numberRows; ++k )
      {
         outs->results->rows.int2u[ k ] = i + k;
      }
   
   
#ifdef USE_OPTIONAL   
      outs->optional = new multiDimData[ 1 ];
      memset( outs->optional, 0, sizeof( multiDimData ) );
   
      outs->optional[ 0 ].numberDimensions = 1;
      outs->optional[ 0 ].dimensions = new UINT4[ 1 ];
      outs->optional[ 0 ].dimensions[ 0 ] = 20;
   
      // Init name
      name = "Optional";
      tmp = name.c_str();
   
      memcpy( outs->optional[ 0 ].name, tmp, strlen( tmp ) );

      // Init units
      name = "OptionalUnits";
      tmp = name.c_str();
   
      memcpy( outs->optional[ 0 ].units, tmp, strlen( tmp ) );         
   
      outs->optional[ 0 ].space = timeD;
      outs->optional[ 0 ].type = int_2s;
      outs->optional[ 0 ].range.dTime.numberSamples = 20;
      outs->optional[ 0 ].range.dTime.startSec = 678908;
      outs->optional[ 0 ].range.dTime.startNan = 0;
      outs->optional[ 0 ].range.dTime.stopSec = 678909;
      outs->optional[ 0 ].range.dTime.stopNan = 0;
      outs->optional[ 0 ].range.dTime.timeStepSize = 0.05;   
      outs->optional[ 0 ].data.int2s = 
            new INT2[ outs->optional[ 0 ].dimensions[ 0 ] ];            

      for( UINT4 j = 0; 
              j < outs->optional[ 0 ].dimensions[ 0 ]; ++j )
      {
          outs->optional[ 0 ].data.int2s[ j ] = 40;
      }   
#endif
   
   }
   
   return;
}

   
//-------------------------------------------------------------------------------   
//   
//: Hard-coded outPut structure generation( with outPut->optional ).
//    
// This method is to simulate outPut data structure with multiDimData 
// generation by dso.
// Used only for debugging purposes.
// MDD data has predefined metadata:
//    1st channel: numberSamples = 2^20, sampleRate = 1024, 
//                 domain = FREQ, datatype = real_4
//    2nd channel: numberSamples = 2^20, sampleRate = 1024, 
//                 domain = FREQ, datatype = complex_8   
//
//!param: outPut** out - A pointer to the array of outPut data structures to    
//+       be allocated.
//!param: const UINT4 num - A number of array elements to allocate.
//
//!return: Nothing.
//
//!exc: bad_alloc - Memory allocation failed.
//   
void buildMDDOutputStruct( outPut** out, const UINT4 num,
   const MPI::Intracomm& comm ) 
{
   if( num != 2 )
   {
      node_error( "Only 2 channels can be generated.", comm );
   }

   
   // Building array of num elements
   const CHAR* tmp( 0 );   
   
   *out = new outPut[ num ];
   memset( *out, 0, sizeof( outPut ) * num );
   
   outPut* outs( 0 );

   // Number of samples is 2^20 + 1
   //UINT8 ndata( 1048576 + 1 );
   UINT8 ndata( 1024 + 1 );
   UINT4 sampleRate( 1024 );
   REAL4 dt( ( ndata - 1 ) / sampleRate );
   REAL8 freqStep( 1.0f / sampleRate );
   REAL8 startFreq( 0 );
   REAL8 stopFreq( ( ndata - 1 ) * freqStep + startFreq );

   // 64-bit optimization bug: generates bad instruction for the code below 
   // (stop_time and stopNan) if it's declared to be of UINT4 type.
   REAL4 startSec( 654321111.0f );
   REAL4 startNan( 0.0f );
   
   REAL4 stop_time( startSec + startNan * 1e-9 + dt );

   UINT4 stopSec( static_cast< UINT4 >( stop_time ) );
   UINT4 stopNan( static_cast< UINT4 >( (stop_time - stopSec )*1e9 ) );

   const UINT4 num_detector( 6 );   

   
   for( UINT4 i = 0; i < num; ++i )
   {
      outs = &( ( *out )[ i ] );
   
      outs->indexNumber = i;
      outs->search = stocastic;
      outs->significant = true;
   
      outs->optional = new multiDimData[ 1 ];
      memset( outs->optional, 0, sizeof( multiDimData ) );
   
      outs->optional[ 0 ].numberDimensions = 1;
      outs->optional[ 0 ].dimensions = new UINT4[ 1 ];
      outs->optional[ 0 ].dimensions[ 0 ] = ndata;
   
      // Init name
      tmp = "optional";
      memcpy( outs->optional[ 0 ].name, tmp, strlen( tmp ) );

      // Init units
      tmp = "optional_units";
      memcpy( outs->optional[ 0 ].units, tmp, strlen( tmp ) );         
   
      outs->optional[ 0 ].space = freqD;
      outs->optional[ 0 ].range.dFreq.numberSamples = ndata;
      // 64-bit optimization bug: generates bad instruction for above code if it's declared
      // to be of UINT4 type.
      outs->optional[ 0 ].range.dFreq.gpsStartTimeSec = static_cast< UINT4 >( startSec );
      outs->optional[ 0 ].range.dFreq.gpsStartTimeNan = static_cast< UINT4 >( startNan );
      outs->optional[ 0 ].range.dFreq.gpsStopTimeSec = stopSec;
      outs->optional[ 0 ].range.dFreq.gpsStopTimeNan = stopNan;
      outs->optional[ 0 ].range.dFreq.freqStepSize = freqStep;   
      outs->optional[ 0 ].range.dFreq.startFreq = startFreq;      
      outs->optional[ 0 ].range.dFreq.stopFreq = stopFreq;         
   
      // Test detector geometry
      outs->optional[ 0 ].range.dFreq.numberDetectors = num_detector;
      outs->optional[ 0 ].range.dFreq.geometry = 
         new detGeom[ num_detector ];
      memset( outs->optional[ 0 ].range.dFreq.geometry, 0, 
              sizeof( detGeom ) * num_detector );   
   
      tmp = "test-detector";
      for( UINT4 d_index = 0; d_index < num_detector; ++d_index )
      {
         strncpy( outs->optional[ 0 ].range.dFreq.geometry[ d_index ].name,
                  tmp, strlen( tmp ) );                       
         outs->optional[ 0 ].range.dFreq.geometry[ d_index ].latitude =    
            ( d_index + 3 ) * 10.0f;
      }   

      // Create 2 node history linked list
      outs->optional[ 0 ].history = new dcHistory;
      memset( outs->optional[ 0 ].history, 0, sizeof( dcHistory ) );
   
      tmp = "NoHistoryPresent_0";
      memcpy( outs->optional[ 0 ].history->name, tmp, strlen( tmp ) );
   
      tmp = "historyUnits_0";
      memcpy( outs->optional[ 0 ].history->units, tmp, strlen( tmp ) ); 
   
      outs->optional[ 0 ].history->type = int_2s;
      outs->optional[ 0 ].history->numberValues = 2;
      outs->optional[ 0 ].history->value.int2s = new INT2[ 2 ];
      outs->optional[ 0 ].history->value.int2s[ 0 ] = 89;
      outs->optional[ 0 ].history->value.int2s[ 1 ] = 109;   
   
      outs->optional[ 0 ].history->next = new dcHistory;
      memset( outs->optional[ 0 ].history->next, 0,
              sizeof( dcHistory ) );
      outs->optional[ 0 ].history->next->previous = 
         outs->optional[ 0 ].history;
   
      tmp = "NoHistoryPresent_1";
      memcpy( outs->optional[ 0 ].history->next->name, tmp,
              strlen( tmp ) );
   
      tmp = "historyUnits_1";
      memcpy( outs->optional[ 0 ].history->next->units, tmp,
              strlen( tmp ) ); 
   
      outs->optional[ 0 ].history->next->type = char_s;
      static const char* history_lstring( "some test data" );
      outs->optional[ 0 ].history->next->numberValues = 
         strlen( history_lstring );
      outs->optional[ 0 ].history->next->value.chars = 
         new CHAR[ outs->optional[ 0 ].history->next->numberValues ];
      memcpy( outs->optional[ 0 ].history->next->value.chars,
              history_lstring, strlen( history_lstring ) );
   
      if( i == 0 )
      {
         outs->optional[ 0 ].type = real_4;
         outs->optional[ 0 ].data.real4 = new REAL4[ ndata ];            

         REAL4* real4_ptr( outs->optional[ 0 ].data.real4 );
         UINT8 j( 0 );
   
         while( j < ndata )
         {
            *real4_ptr = j;
            ++j;
            ++real4_ptr;
         }   
      }
      else
      {
         outs->optional[ 0 ].type = complex_8;
         outs->optional[ 0 ].data.complex8 = new COMPLEX8[ ndata ];            

         COMPLEX8* complex8_ptr( outs->optional[ 0 ].data.complex8 );
         UINT8 j( 0 );
   
         while( j < ndata )
         {
            ( *complex8_ptr ).re = j;
            ( *complex8_ptr ).im = j;   
            ++j;
            ++complex8_ptr;
         }   
      }   
   }
   
   return;
}
   

//-------------------------------------------------------------------------------   
//   
//: Hard-coded empty outPut structure generation.
//    
// This method is to simulate outPut data structure generation by dso.
// The structure is empty, meaning it doesn't contain either dataBase or   
// stateVector data.   
// Used only for debugging purposes.
//
//!param: outPut** out - A pointer to the array of outPut data structures to    
//+       be allocated.
//!param: const UINT4 num - A number of array elements to allocate.
//
//!return: Nothing.
//
//!exc: bad_alloc - Memory allocation failed.
//   
void buildNullOutputStruct( outPut** out, const UINT4 num ) 
{
   // Building array of num elements
   *out = new outPut[ num ];
   memset( *out, 0, sizeof( outPut ) * num );
   
   
   outPut* outs( 0 );
   
   
   for( UINT4 i = 0; i < num; ++i )
   {
      outs = &( ( *out )[ i ] );
   
      //cout << "buildOutput: " << i << endl;
      outs->indexNumber = 100 + i;
      outs->search = burst;
      outs->significant = 55;
      //cout << "Significant = " << out[ i ].significant << endl;
   }
   
   return;
}

   
